// CountImpl.java
// implements Count interface functions

package counter;


import org.omg.CORBA.ORB;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;



public class CountImpl extends counter._CountImplBase
{
	// instance variable, these are the attributes from the IDL definition
	long	sum;
	long	sum_sq;
	double	sum_sqrt;

	// constructor
    public CountImpl(String params[]) throws Exception
    {
		register("CountServer", params);
    }
    
    private void register(String corbaName, String params[])
		throws org.omg.CORBA.ORBPackage.InvalidName,
			org.omg.CosNaming.NamingContextPackage.InvalidName,
			CannotProceed, 
			NotFound
    {
		if( (corbaName == null) || (corbaName.trim().length() == 0) )
	    {
			throw new IllegalArgumentException("Registration cannot be null or blank");
	    }
	
		ORB orb = ORB.init(params, null);
	
		orb.connect(this);
	
		org.omg.CORBA.Object corbaObject = orb.resolve_initial_references("NameService");
		NamingContext naming = NamingContextHelper.narrow(corbaObject);
	
		NameComponent namingComponent = new NameComponent(corbaName, "");
		NameComponent path[] = { namingComponent };
	
		naming.rebind(path, this);
		System.out.println("Rebind complete");
    }
   

	// accessor methods
    public long		sum () { return sum; }
    public void		sum (long newSum) { sum = newSum; }

    public long		sum_sq () { return sum_sq; }
    public void		sum_sq (long newSum_sq) { sum_sq = newSum_sq; }

    public double	sum_sqrt () { return sum_sqrt; }
    public void		sum_sqrt (double newSum_sqrt) { sum_sqrt = newSum_sqrt; }

    public void init_sum ()
    {
		sum = 0;
    }

    public void increment ()
    {
		sum++;
    }

    public void compute_sum_square()
    {
		sum_sq = sum * sum;
    }

    public void compute_sum_sqroot ()
    {
		sum_sqrt =  Math.sqrt( sum );
    }

	// main method
    public static void main(String args[]) throws Exception
    {
		Count countObject = new CountImpl(args);
	
		java.lang.Object object = new java.lang.Object();
	
		synchronized(object)
	    {
			object.wait();
	    }
    }
}
